unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ExtCtrls, TeeProcs, TeEngine, Chart, DbChart, DBClient,
  StdCtrls, Series, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ClientDataSet1: TClientDataSet;
    DBChart1: TDBChart;
    ClientDataSet1Seq: TIntegerField;
    ClientDataSet1deformity: TFloatField;
    ClientDataSet1Temperature: TFloatField;
    DBGrid1: TDBGrid;
    Series1: TLineSeries;
    Series2: TLineSeries;
    DataSource1: TDataSource;
    ClientDataSet1CDateTime: TDateTimeField;
    Button2: TButton;
    Edit1: TEdit;
    ClientDataSet1Deformity1: TFloatField;
    Series3: TLineSeries;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  i : integer;
begin
  ClientDataSet1.Close;
  ClientDataSet1.CreateDataSet;
  randomize;
  for i := 1 to 10 do
    begin
      with ClientDataSet1 do
        begin
          Append;
          FieldByName('Seq').AsInteger := i;
          FieldByName('CDateTime').AsDateTime := Now + (i * 0.1);
          FieldByName('Deformity').AsFloat := Random(1000)/100;
          FieldByName('Deformity1').AsFloat := FieldByName('Deformity').AsFloat;
          FieldByName('Temperature').AsFloat := 26+(Random(200)/100);
          Post;
        end;
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  MV : Double;
  SavePlace : TBookmark;
begin
  if TryStrToFloat(Edit1.Text,MV) then
    begin
      with ClientDataSet1 do
        begin
          First;
          while not Eof do
            begin
              SavePlace := GetBookmark;
              try
                Edit;
                FieldByName('Deformity1').AsFloat := FieldByName('Deformity1').AsFloat + MV;
                GotoBookmark(SavePlace);
                Next;
              finally
                FreeBookmark(SavePlace);
              end;
            end;
        end;
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  SavePlace : TBookmark;
begin
  with ClientDataSet1 do
    begin
      First;
      while not Eof do
        begin
          SavePlace := GetBookmark;
          try
            Edit;
            FieldByName('Deformity1').AsFloat := FieldByName('Deformity').AsFloat;
            GotoBookmark(SavePlace);
            Next;
          finally
            FreeBookmark(SavePlace);
          end;
        end;
    end;
end;

end.
